<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="100px">
      <el-form-item label="检查记录编码" prop="fCheckCode">
        <el-input
          v-model="queryParams.fCheckCode"
          placeholder="请输入检查记录编码"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="调研项目名称" prop="fName">
        <el-input
          v-model="queryParams.fName"
          placeholder="请输入调研项目名称"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="调研方法" prop="fMethod">
        <el-select v-model="queryParams.fMethod" placeholder="请选择调研方法" clearable size="small">
          <el-option
            v-for="dict in fMethodOptions"
            :key="dict.dictValue"
            :label="dict.dictLabel"
            :value="dict.dictValue"
          />
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
		      :loading="exportLoading"
          @click="handleExport"
        >导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="inforList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="检查记录编码" align="center" prop="fCheckCode" />
      <el-table-column label="检查任务名称" align="center" prop="taskName" />
      <el-table-column label="检查任务编号" align="center" prop="taskCode" />
      <el-table-column label="调研项目名称" align="center" prop="fName" />
      <el-table-column label="调研内容" align="center" prop="fContent" :show-overflow-tooltip="true">
        <template slot-scope="scope">
          <span v-if="scope.row.fContent">{{ scope.row.fContent }}</span>
          <span v-else>-</span>
        </template>
      </el-table-column>
      <el-table-column label="调研方法" align="center" prop="fMethod" :formatter="fMethodFormat" />
      <el-table-column label="调研结果" align="center" prop="fResult" :show-overflow-tooltip="true">
        <template slot-scope="scope">
          <span v-if="scope.row.fResult">{{ scope.row.fResult }}</span>
          <span v-else>-</span>
        </template>
      </el-table-column>
      <el-table-column label="更新时间" align="center" prop="fUpdateTime" width="150">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.fUpdateTime, '{y}-{m}-{d} {h}:{i}:{s}') }}</span>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width" width="200">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-document"
            @click="handleDetail(scope.row)"
          >详情</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
          >删除</el-button>
          <el-button
            size="mini"
            type="text"
            @click="handleReport(scope.row)"
          >上传</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改调查结果对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="900px" append-to-body destroy-on-close :close-on-click-modal="false">
      <el-form ref="form" :model="form" :rules="rules" label-width="120px">
        <el-row class="el-row-table">
          <el-col :span="12">
            <el-form-item label="检查记录" prop="fCheckCode">
              <el-select
                v-model="form.fCheckCode"
                placeholder="请选择检查记录编码"
                style="width: 100%"
              >
                <el-option
                  v-for="record in records"
                  :key="record.fInsRecInforId"
                  :label="record.taskName + ' + '+record.fCheckCode"
                  :value="record.fCheckCode"
                ></el-option>
              </el-select>
            </el-form-item>
          </el-col>

          <el-col :span="12">
            <el-form-item label="调研项目名称" prop="fName">
              <el-input v-model="form.fName" placeholder="请输入调研项目名称" />
            </el-form-item>
          </el-col>

          <el-col :span="12">
            <el-form-item label="调研方法" prop="fMethod">
              <el-select
                v-model="form.fMethod"
                placeholder="请选择调研方法"
                style="width: 100%"
              >
                <el-option
                  v-for="dict in fMethodOptions"
                  :key="dict.dictValue"
                  :label="dict.dictLabel"
                  :value="dict.dictValue"
                ></el-option>
              </el-select>
            </el-form-item>
          </el-col>

          <el-col :span="24">
            <el-form-item label="调研内容">
             <!-- <editor v-model="form.fContent" :min-height="192"/>-->
              <el-input type="textarea" v-model="form.fContent" placeholder="请输入调研内容" />
            </el-form-item>
          </el-col>

          <el-col :span="24">
            <el-form-item label="调研结果" prop="fResult">
              <el-input type="textarea" v-model="form.fResult" placeholder="请输入调研结果" />
            </el-form-item>
          </el-col>

        </el-row>

      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>

    <!-- 详情 -->
    <DetailInfo ref="detail"/>
  </div>
</template>

<script>
import { listInfor, getInfor, delInfor, addInfor, updateInfor, exportInfor, reportSpotRecInfo } from "@/api/supervision/findings";
import Editor from '@/components/Editor';
import { recordList } from "@/api/supervision/record";
import DetailInfo from "./components/DetailInfo";
export default {
  name: "Infor",
  components: {
    Editor,
    DetailInfo
  },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 选中数组
      ids: [],
      fNames: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 调查结果表格数据
      inforList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 调研方法
      fMethodOptions: [],
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        fCheckCode: null,
        fName: null,
        fMethod: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        fCheckCode: [
          { required: true, message: "检查记录编码", trigger: "blur" }
        ],
        fName: [
          { required: true, message: "调研项目名称不能为空", trigger: "blur" }
        ],
        fMethod: [
          { required: true, message: "调研方法", trigger: "change" }
        ],
      },
      records: []
    };
  },
  created() {
    this.getList();
    this.getDicts("t_survey_method").then(response => {
      this.fMethodOptions = response.data;
    });
  },
  methods: {
    /** 查询调查结果列表 */
    getList() {
      this.loading = true;
      listInfor(this.queryParams).then(response => {
        this.inforList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 调研方法
    fMethodFormat(row, column) {
      return this.selectDictLabel(this.fMethodOptions, row.fMethod);
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        fInsSpotRecInforId: null,
        fCheckCode: null,
        fName: null,
        fContent: null,
        fMethod: null,
        fResult: null,
        fUpdateTime: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.fInsSpotRecInforId);
      this.fNames = selection.map(item => item.fName);
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.getRecordList();
      this.open = true;
      this.title = "添加调查结果";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const fInsSpotRecInforId = row.fInsSpotRecInforId || this.ids
      getInfor(fInsSpotRecInforId).then(response => {
        this.form = response.data;
        this.getRecordList();
        this.open = true;
        this.title = "修改调查结果";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.fInsSpotRecInforId != null) {
            updateInfor(this.form).then(response => {
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addInfor(this.form).then(response => {
              this.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const fInsSpotRecInforIds = row.fInsSpotRecInforId || this.ids;
      const fNames = row.fName || this.fNames;
      this.$confirm('是否确认删除调查结果名称为"' + fNames + '"的数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delInfor(fInsSpotRecInforIds);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有调查结果数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(() => {
          this.exportLoading = true;
          return exportInfor(queryParams);
        }).then(response => {
          this.download(response.msg);
          this.exportLoading = false;
        }).catch(() => {});
    },
    getRecordList(){
      recordList().then(res =>{
        if(res.code == 200 && res.data){
          this.records = res.data;
        }
      })
    },
    //详情
    handleDetail(row){
      this.$refs.detail.getDetailInfo(row.fInsSpotRecInforId);
    },
    //上传
    handleReport(row) {
      this.$confirm('是否确认上传调查结果名称为"' + row.fName + '"的数据项?', "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      }).then(function() {
        return reportSpotRecInfo({fInsSpotRecInforId: row.fInsSpotRecInforId});
      }).then(() => {
        this.getList();
        this.msgSuccess("上传成功");
      }).catch(() => {});
    },
  }
};
</script>
